> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve a list of insight types

> Insight types are generalized categories that encompass various specific occurrences of the same kind.



## OpenAPI

````yaml /api-reference/services_documented/waap_api.yaml get /waap/v1/security-insights/types
openapi: 3.1.0
info:
  title: Gcore OpenAPI – WAAP API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-07T20:33:46.548242+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: WAAP Service
    x-displayName: WAAP Service
  - name: Domains
    x-displayName: Domains
  - name: Policies
    x-displayName: Policies
  - name: Analytics
    x-displayName: Analytics
  - name: Custom Page Sets
    x-displayName: Custom Page Sets
  - name: Custom Rules
    x-displayName: Custom Rules
  - name: Filter Templates
    x-displayName: Filter Templates
  - name: Firewall Rules
    x-displayName: Firewall Rules
  - name: Advanced Rules
    x-displayName: Advanced Rules
  - name: Tags
    x-displayName: Tags
  - name: Network Organizations
    x-displayName: Network Organizations
  - name: API Discovery
    x-displayName: API Discovery
  - name: IP Spotlight
    x-displayName: IP Spotlight
  - name: Security Insights
    x-displayName: Security Insights
  - name: IP Reputation
    x-displayName: IP Reputation
paths:
  /waap/v1/security-insights/types:
    get:
      tags:
        - Security Insights
      summary: Retrieve a list of insight types
      description: >-
        Insight types are generalized categories that encompass various specific
        occurrences of the same kind.
      operationId: get_insight_types_v1_security_insights_types_get
      parameters:
        - name: ordering
          in: query
          required: false
          schema:
            enum:
              - name
              - '-name'
              - slug
              - '-slug'
              - insight_frequency
              - '-insight_frequency'
            type: string
            description: Sort the response by given field.
            default: name
            title: Ordering
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 0
            description: Number of items to return
            default: 100
            title: Limit
          description: Number of items to return
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            maximum: 100000
            minimum: 0
            description: Number of items to skip
            default: 0
            title: Offset
          description: Number of items to skip
        - name: name
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Filter by the name of the insight type
            title: Name
          description: Filter by the name of the insight type
        - name: slug
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                pattern: ^[a-z0-9]+(?:-[a-z0-9]+)*$
                description: The slug of the insight type
              - type: 'null'
            description: Filter by the slug of the insight type
            title: Slug
          description: Filter by the slug of the insight type
        - name: insight_frequency
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                exclusiveMinimum: 0
              - type: 'null'
            description: Filter by the frequency of the insight type
            title: Insight Frequency
          description: Filter by the frequency of the insight type
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedResponse_InsightType_'
        '400':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-bad-request
                title: Bad Request
                status: 400
                detail: 'Invalid domain name: '''''''''
          description: Bad Request
        '401':
          description: Unauthorized
          content:
            application/problem+json:
              example:
                detail: Auth token is missing or invalid
        '403':
          description: Unauthenticated
          content:
            application/problem+json:
              example:
                detail: Permission denied
        '404':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-not-found
                title: Not Found
                status: 404
                detail: The resource is not found
          description: Not Found
        '422':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APICompositeError'
              example:
                type: request-validation-failed
                title: Request validation error.
                status: 422
                detail: One or more fields have validation errors.
                errors:
                  - loc:
                      - body
                      - name
                    detail: Input should be a valid string
                  - loc:
                      - body
                      - date
                    detail: Field required
                  - loc:
                      - query
                      - limit
                    detail: Field required
          description: Unprocessable Entity
        '500':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: internal-server-error
                title: Internal server error.
                status: 500
                detail: >-
                  An unexpected condition was encountered which prevented the
                  server from fulfilling the request.
          description: Internal Server Error
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            page = client.waap.insights.list_types()
            page = page.results[0]
            print(page.description)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/option\"\n\t\"github.com/G-Core/gcore-go/waap\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.Waap.Insights.ListTypes(context.TODO(), waap.InsightListTypesParams{})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
components:
  schemas:
    PaginatedResponse_InsightType_:
      properties:
        limit:
          type: integer
          title: Limit
          description: Number of items requested in the response
        offset:
          type: integer
          title: Offset
          description: Items response offset used
        count:
          type: integer
          title: Count
          description: Number of items contain in the response
        results:
          items:
            $ref: '#/components/schemas/InsightType'
          type: array
          title: Results
          description: List of items returned in the response following given criteria
      type: object
      required:
        - limit
        - offset
        - count
        - results
      title: PaginatedResponse[InsightType]
    APIError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
      type: object
      required:
        - type
        - title
        - status
        - detail
      title: APIError
    APICompositeError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
        errors:
          items:
            $ref: '#/components/schemas/APIFieldError'
          type: array
          title: Errors
          description: A list of detailed errors for individual fields.
      type: object
      required:
        - type
        - title
        - status
        - detail
        - errors
      title: APICompositeError
    InsightType:
      properties:
        name:
          type: string
          title: Name
          description: The name of the insight type
        description:
          type: string
          title: Description
          description: The description of the insight type
        slug:
          type: string
          pattern: ^[a-z0-9]+(?:-[a-z0-9]+)*$
          title: Slug
          description: The slug of the insight type
          example: high-risk-ip
          examples:
            - high-risk-ip
            - attack-on-disabled-policy
        labels:
          items:
            type: string
          type: array
          title: Labels
          description: The labels of the insight type
        insight_template:
          type: string
          title: Insight Template
          description: The insight template
        recommendation_template:
          type: string
          title: Recommendation Template
          description: The recommendation template
        insight_grouping_dimensions:
          items:
            type: string
          type: array
          title: Insight Grouping Dimensions
          description: The grouping dimensions of the insight type
        insight_frequency:
          type: integer
          title: Insight Frequency
          description: The frequency of the insight type
      type: object
      required:
        - name
        - description
        - slug
        - labels
        - insight_template
        - recommendation_template
        - insight_grouping_dimensions
        - insight_frequency
      title: InsightType
    APIFieldError:
      properties:
        loc:
          anyOf:
            - items:
                anyOf:
                  - type: integer
                  - type: string
              type: array
            - {}
          title: Loc
          description: The location of the field or a character number causing the error.
        detail:
          type: string
          title: Detail
          description: A human-readable message describing the error.
      type: object
      required:
        - loc
        - detail
      title: APIFieldError
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````